Index: roard/clients.c
===================================================================
--- roard/clients.c	(revision 6052)
+++ roard/clients.c	(revision 0)
@@ -1000,229 +255,30 @@
 }
 
-int clients_add_output (int id, struct roar_buffer ** buf) {
- struct roar_client_server   * cs;
-
- _CHECK_CID(id);
- cs = g_clients[id];
-
- if ( cs->outbuf == NULL ) {
-  cs->outbuf = *buf;
- } else {
-  return roar_buffer_moveinto(cs->outbuf, buf);
- }
-
- return 0;
-}
-
-// proto support
-const struct roard_proto_handle * clients_get_protohandle(const int proto) {
- size_t i;
-
- if ( proto < 0 ) {
-  roar_err_set(ROAR_ERROR_INVAL);
-  return NULL;
- }
-
- for (i = 0; i < (sizeof(__protos)/sizeof(*__protos)); i++)
-  if ( __protos[i].proto == proto )
-   return &(__protos[i]);
-
- roar_err_set(ROAR_ERROR_NOENT);
- return NULL;
-}
-
-int clients_register_proto_common(const struct roar_dl_proto * proto, struct roar_dl_lhandle * lhandle) {
- const size_t len = sizeof(__protos)/sizeof(*__protos);
- size_t i;
-
- ROAR_DBG("clients_register_proto_common(proto=%p, lhandle=%p) = ?", proto, lhandle);
-
- if ( proto == NULL )
-  return -1;
-
- for (i = 0; __protos[i].proto != -1; i++);
-
- // i is now at pos of current EOS entry.
-
- // test if we have space for one more entry:
- if ( (i+1) >= len )
-  return -1;
-
- __protos[i].impl.common = proto;
-
- __protos[i].proto   = proto->proto;
- __protos[i].type    = ROARD_PROTO_TYPE_COMMON;
- __protos[i].lhandle = lhandle;
-
- return 0;
-}
-
-int clients_unregister_proto(int proto) {
- size_t i;
-
- if ( proto < 0 ) {
-  roar_err_set(ROAR_ERROR_RANGE);
-  return -1;
- }
-
- for (i = 0; i < (sizeof(__protos)/sizeof(*__protos)); i++) {
-  if ( __protos[i].proto == proto ) {
-   memset(&(__protos[i]), 0, sizeof(*__protos));
-   __protos[i].proto = -1;
+int client_stream_exec   (int client, int stream) {
+ int i;
+
+ if ( g_clients[client] == NULL )
+  return -1;
+
+ for (i = 0; i < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; i++) {
+  if ( g_clients[client]->streams[i] == stream ) {
+   g_clients[client]->execed = stream;
+   streams_set_fh(stream, g_clients[client]->fh);
    return 0;
   }
  }
 
- roar_err_set(ROAR_ERROR_NOENT);
- return -1;
-}
-
-void print_protolist        (enum output_format format) {
- struct roard_proto_handle * p;
- char flags[5] = "    ";
- char subsys[7] = "      ";
- const char * description;
- size_t i;
-
- switch (format) {
-  case FORMAT_NATIVE:
-    printf("  Protocol Flag Subsys - Description\n");
-    printf("------------------------------------------------------\n");
-    printf("  roar     bb   WM LRX - RoarAudio native protocol\n");
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_SIMPLE
-    printf("  simple   bb   WM LRX - PulseAudio simple protocol\n");
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_RSOUND
-    printf("  rsound   bb   W      - RSound emulation\n");
-#endif
-   break;
-  case FORMAT_WIKI:
-    printf("||=Protocol =||=Flag =||=Subsys =||=Description              =||\n");
-    printf("||roar       ||bb     ||WM LRX   ||RoarAudio native protocol  ||\n");
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_SIMPLE
-    printf("||simple     ||bb     ||WM LRX   ||PulseAudio simple protocol ||\n");
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_RSOUND
-    printf("||rsound     ||bb     ||W        ||RSound emulation           ||\n");
-#endif
-   break;
-  case FORMAT_CSV:
-    printf("Protocol,Flag,Subsys,Description\n");
-    printf("roar,bb,WM LRX,RoarAudio native protocol\n");
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_SIMPLE
-    printf("simple,bb,WM LRX,PulseAudio simple protocol\n");
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_EMUL_RSOUND
-    printf("rsound,bb,W,RSound emulation\n");
-#endif
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_NOTSUP);
-    return;
- }
-
- for (i = 0; i < (sizeof(__protos)/sizeof(*__protos)); i++) {
-  p = &(__protos[i]);
-  if ( p->proto == -1 )
-   continue;
-
-  strncpy(flags, "    ", 4);
-  strncpy(subsys, "      ", 6);
-  description = "(none)";
-
-  if ( p->lhandle != NULL ) {
-   flags[0] = 'P';
-  } else {
-   flags[0] = 'b';
-  }
-
-  switch (p->type) {
-   case ROARD_PROTO_TYPE_BUILDIN:
-     continue;
-    break;
-   case ROARD_PROTO_TYPE_COMMON:
-     flags[1] = 'C';
-     description = p->impl.common->description;
-    break;
-  }
-
-  switch (format) {
-   case FORMAT_NATIVE:
-     printf("  %-8s %s %s - %s\n", roar_proto2str(p->proto), flags, subsys, description);
-    break;
-   case FORMAT_WIKI:
-     printf("||%s ||%s ||%s ||%s ||\n", roar_proto2str(p->proto), flags, subsys, description);
-    break;
-   case FORMAT_CSV:
-     printf("%s,%s,%s,%s\n", roar_proto2str(p->proto), flags, subsys, description);
-    break;
-  }
- }
-}
-
-int client_stream_exec   (int client, int stream) {
- struct roar_client * c;
- int i;
- int fh;
-
- _CHECK_CID(client);
-
-#if 0
- if ( g_clients[client] == NULL ) {
-  ROAR_WARN("client_stream_exec(client=%i, stream=%i) = -1 // client does not exist", client, stream);
-  return -1;
- }
-#endif
-
- c = ROAR_CLIENT(g_clients[client]);
+ return -1;
+}
+
+int client_stream_add    (int client, int stream) {
+ int i;
+
+ if ( g_clients[client] == NULL )
+  return -1;
 
  for (i = 0; i < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; i++) {
-  if ( c->streams[i] == stream ) {
-   c->execed = stream;
-   if ( streams_is_ready(stream) == 0 ) {
-    streams_set_fh(stream, c->fh);
-    streams_set_socktype(stream, ROAR_SOCKET_TYPE_GENSTR);
-   } else {
-    ROAR_DBG("client_stream_exec(client=%i, stream=%i): fh=?", client, stream);
-    if ( (fh = c->fh) != -1 ) {
-     close(fh);
-     c->fh = -1;
-    }
-   }
-   ROAR_DBG("client_stream_exec(client=%i, stream=%i) = 0", client, stream);
-   return 0;
-  }
- }
-
- ROAR_WARN("client_stream_exec(client=%i, stream=%i) = -1 // client does not own stream", client, stream);
- return -1;
-}
-
-int client_stream_set_fh (int client, int stream, int fh) {
- int i;
-
- ROAR_DBG("client_stream_set_fh(client=%i, stream=%i, fh=%i) = ?", client, stream, fh);
-
- _CHECK_CID(client);
-
- for (i = 0; i < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; i++) {
-  if ( ROAR_CLIENT(g_clients[client])->streams[i] == stream ) {
-   ROAR_DBG("client_stream_set_fh(client=%i, stream=%i, fh=%i): stream found, index %i", client, stream, fh, i);
-   return streams_set_fh(stream, fh);
-  }
- }
-
- ROAR_WARN("client_stream_set_fh(client=%i, stream=%i, fh=%i) = -1 // client does not own stream", client, stream, fh);
- return -1;
-}
-
-int client_stream_add    (int client, int stream) {
- int i;
-
- _CHECK_CID(client);
-
- for (i = 0; i < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; i++) {
-  if ( ROAR_CLIENT(g_clients[client])->streams[i] == -1 ) {
-   ROAR_CLIENT(g_clients[client])->streams[i] = stream;
+  if ( g_clients[client]->streams[i] == -1 ) {
+   g_clients[client]->streams[i] = stream;
    streams_set_client(stream, client);
    return 0;
@@ -1236,11 +292,12 @@
  int i;
 
- _CHECK_CID(client);
+ if ( g_clients[client] == NULL )
+  return -1;
 
  for (i = 0; i < ROAR_CLIENTS_MAX_STREAMS_PER_CLIENT; i++) {
-  if ( ROAR_CLIENT(g_clients[client])->streams[i] == stream ) {
-   ROAR_CLIENT(g_clients[client])->streams[i] = -1;
-
-   if ( stream == ROAR_CLIENT(g_clients[client])->execed ) {
+  if ( g_clients[client]->streams[i] == stream ) {
+   g_clients[client]->streams[i] = -1;
+
+   if ( stream == g_clients[client]->execed ) {
     ROAR_DBG("client_stream_delete(client=%i, stream=%i): stream is execed one, deleting client!", client, stream);
     clients_delete(client);
@@ -1256,132 +313,3 @@
 }
 
-int client_stream_move   (int client, int stream) {
- int old_client = streams_get_client(stream);
-
- ROAR_DBG("client_stream_move(client=%i, stream=%i): old_client = %i", client, stream, old_client);
-
- if ( old_client != -1 )
-  if ( client_stream_delete(old_client, stream) == -1 )
-   return -1;
-
- return client_stream_add(client, stream); 
-}
-
-
-// notify thingys
-int clients_wait    (int client, struct roar_event * events, size_t num) {
- struct roar_client_server * cs;
- size_t i, c;
-
- ROAR_DBG("clients_wait(client=%i, events=%p, num=%llu) = ?", client, events, (long long unsigned int)num);
-
- _CHECK_CID(client);
-
- cs = g_clients[client];
-
- if ( cs->waits != NULL )
-  return -1;
-
- cs->waits = roar_mm_malloc((num+1) * sizeof(struct roar_subscriber *));
-
- if ( cs->waits == NULL )
-  return -1;
-
- if ( clients_block(client, 0) != 0 )
-  return -1;
-
- for (i = 0; i < num; i++) {
-#if defined(DEBUG) && 0
-  dbg_notify_cb(NULL, &(events[i]), cs);
-#endif
-  cs->waits[i] = roar_notify_core_subscribe(NULL, &(events[i]), clients_ncb_wait, cs);
-  if ( cs->waits[i] == NULL ) {
-   for (c = 0; c < i; c++)
-    roar_notify_core_unsubscribe(NULL, cs->waits[c]);
-   roar_mm_free(cs->waits);
-   cs->waits = NULL;
-   clients_block(client, 1);
-   return -1;
-  }
- }
-
- cs->waits[num] = NULL;
-
- ROAR_DBG("clients_wait(client=%i, events=%p, num=%llu) = 0", client, events, (long long unsigned int)num);
- return 0;
-}
-
-void clients_ncb_wait(struct roar_notify_core * core, struct roar_event * event, void * userdata) {
- struct roar_client_server * cs = userdata;
- struct roar_message m;
- struct roar_connection con;
- uint16_t * u16 = (uint16_t *) m.data;
- size_t tmp;
- size_t i;
-
- ROAR_DBG("clients_ncb_wait(core=%p, event=%p, userdata=%p) = ?", core, event, userdata);
-
- for (i = 0; cs->waits[i] != NULL; i++)
-  roar_notify_core_unsubscribe(NULL, cs->waits[i]);
-
- roar_mm_free(cs->waits);
- cs->waits = NULL;
-
- // protocol depended handling...
- memset(&m, 0, sizeof(m));
- m.cmd = ROAR_CMD_OK;
- u16[0] = ROAR_HOST2NET16(0); // Version
- u16[1] = ROAR_HOST2NET16(0); // flags
-
- tmp = sizeof(m.data) - 4;
-
- roar_event_to_blob(event, m.data + 4, &tmp);
-
- m.datalen = tmp + 4;
-
- roar_connect_fh(&con, ROAR_CLIENT(cs)->fh);
- roar_send_message(&con, &m, NULL);
- // ...end of protocol depended handling.
-
-// clients_block(, 1);
- // TODO: FIXME: bad hack...
- cs->blockc--;
-}
-
-
-// acclev:
-static struct {
- const enum roard_client_acclev acclev;
- const char *                   name;
-} _g_acclevs[] = {
- {ACCLEV_NONE,    "none"   },
- {ACCLEV_IDENTED, "idented"},
- {ACCLEV_CONCTL,  "conctl" },
- {ACCLEV_GUEST,   "guest"  },
- {ACCLEV_USER,    "user"   },
- {ACCLEV_PWRUSER, "pwruser"},
- {ACCLEV_ALL,     "all"    },
- {-1, NULL}
-};
-
-enum roard_client_acclev clients_str2acclev(const char * acclev) {
- int i;
-
- for (i = 0; _g_acclevs[i].name != NULL; i++)
-  if ( !strcasecmp(_g_acclevs[i].name, acclev) )
-   return _g_acclevs[i].acclev;
-
- return ACCLEV_ERROR;
-}
-
-const char * clients_acclev2str(const enum roard_client_acclev acclev) {
- int i;
-
- for (i = 0; _g_acclevs[i].name != NULL; i++)
-  if ( _g_acclevs[i].acclev == acclev )
-   return _g_acclevs[i].name;
-
- return NULL;
-}
-
 //ll
Index: roard/commands.c
===================================================================
--- roard/commands.c	(revision 6052)
+++ roard/commands.c	(revision 0)
@@ -1,84 +1,29 @@
 //commands.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #include "roard.h"
 
-#if !defined(ROAR_TARGET_MICROCONTROLLER) && !defined(ROAR_MINIMAL)
-#define _NAME(x) (x)
-#else
-#define _NAME(x) ((char*)NULL)
-#endif
+struct roar_command g_commands[COMMAND_MAX_COMMANDS] = {
+  {ROAR_CMD_NOOP,         "NOOP",         req_on_noop},
+  {ROAR_CMD_IDENTIFY,     "IDENTIFY",     req_on_identify},
+  {ROAR_CMD_AUTH,         "AUTH",         req_on_auth},
+  {ROAR_CMD_NEW_STREAM,   "NEW_STREAM",   req_on_new_stream},
+  {ROAR_CMD_SET_META,     "SET_META",     req_on_set_meta},
+  {ROAR_CMD_EXEC_STREAM,  "EXEC_STREAM",  req_on_exec_stream},
+  {ROAR_CMD_QUIT,         "QUIT",         clients_delete},
 
-struct roar_command g_commands[COMMAND_MAX_COMMANDS] = {
-  {ROAR_CMD_NOOP,         _NAME("NOOP"),         req_on_noop,         ACCLEV_NONE},
-  {ROAR_CMD_IDENTIFY,     _NAME("IDENTIFY"),     req_on_identify,     ACCLEV_NONE},
-  {ROAR_CMD_AUTH,         _NAME("AUTH"),         req_on_auth,         ACCLEV_IDENTED},
-  {ROAR_CMD_WHOAMI,       _NAME("WHOAMI"),       req_on_whoami,       ACCLEV_NONE},
+  {ROAR_CMD_SERVER_OINFO, "SERVER_OINFO", req_on_server_oinfo},
+  {ROAR_CMD_GET_STANDBY,  "GET_STANDBY",  req_on_get_standby},
+  {ROAR_CMD_SET_STANDBY,  "SET_STANDBY",  req_on_set_standby},
+  {ROAR_CMD_EXIT,         "EXIT",         req_on_exit},
 
+  {ROAR_CMD_LIST_CLIENTS, "LIST_CLIENTS", req_on_list_clients},
+  {ROAR_CMD_LIST_STREAMS, "LIST_STREAMS", req_on_list_streams},
+  {ROAR_CMD_GET_CLIENT,   "GET_CLIENT",   req_on_get_client},
+  {ROAR_CMD_GET_STREAM,   "GET_STREAM",   req_on_get_stream},
+  {ROAR_CMD_KICK,         "KICK",         req_on_kick},
 
-  {ROAR_CMD_NEW_STREAM,   _NAME("NEW_STREAM"),   req_on_new_stream,   ACCLEV_USER},
+  {ROAR_CMD_ADD_DATA,     "ADD_DATA",     req_on_add_data},
 
-#ifdef ROAR_SUPPORT_META
-  {ROAR_CMD_SET_META,     _NAME("SET_META"),     req_on_set_meta,     ACCLEV_PWRUSER},
-  {ROAR_CMD_GET_META,     _NAME("GET_META"),     req_on_get_meta,     ACCLEV_GUEST},
-  {ROAR_CMD_LIST_META,    _NAME("LIST_META"),    req_on_list_meta,    ACCLEV_GUEST},
-#endif
-
-  {ROAR_CMD_EXEC_STREAM,  _NAME("EXEC_STREAM"),  req_on_exec_stream,  ACCLEV_PWRUSER},
-  {ROAR_CMD_QUIT,         _NAME("QUIT"),         req_on_quit, ACCLEV_NONE},
-
-  {ROAR_CMD_CON_STREAM,   _NAME("CON_STREAM"),   req_on_con_stream,   ACCLEV_PWRUSER},
-  {ROAR_CMD_PASSFH,       _NAME("PASSFH"),       req_on_passfh,       ACCLEV_PWRUSER},
-
-  {ROAR_CMD_GETTIMEOFDAY, _NAME("GETTIMEOFDAY"), req_on_gettimeofday, ACCLEV_NONE},
-  {ROAR_CMD_SERVER_INFO,  _NAME("SERVER_INFO"),  req_on_server_info,  ACCLEV_NONE},    // allow this early so the client
-                                                                                       // can decide early if this server
-                                                                                       // provieds all needed features
-  {ROAR_CMD_SERVER_OINFO, _NAME("SERVER_OINFO"), req_on_server_oinfo, ACCLEV_IDENTED}, // same as above
-  {ROAR_CMD_CAPS,         _NAME("CAPS"),         req_on_caps,         ACCLEV_IDENTED}, // and again the same
-  {ROAR_CMD_GET_STANDBY,  _NAME("GET_STANDBY"),  req_on_get_standby,  ACCLEV_GUEST},
-  {ROAR_CMD_SET_STANDBY,  _NAME("SET_STANDBY"),  req_on_set_standby,  ACCLEV_PWRUSER}, // should this be set to ACCLEV_ALL?
-  {ROAR_CMD_EXIT,         _NAME("EXIT"),         req_on_exit,         ACCLEV_ALL},
-
-  {ROAR_CMD_LIST_CLIENTS, _NAME("LIST_CLIENTS"), req_on_list_clients, ACCLEV_GUEST},
-  {ROAR_CMD_LIST_STREAMS, _NAME("LIST_STREAMS"), req_on_list_streams, ACCLEV_GUEST},
-  {ROAR_CMD_GET_CLIENT,   _NAME("GET_CLIENT"),   req_on_get_client,   ACCLEV_GUEST},
-  {ROAR_CMD_GET_STREAM,   _NAME("GET_STREAM"),   req_on_get_stream,   ACCLEV_GUEST},
-  {ROAR_CMD_KICK,         _NAME("KICK"),         req_on_kick,         ACCLEV_PWRUSER},
-  {ROAR_CMD_ATTACH,       _NAME("ATTACH"),       req_on_attach,       ACCLEV_PWRUSER},
-  {ROAR_CMD_SET_VOL,      _NAME("SET_VOL"),      req_on_set_vol,      ACCLEV_PWRUSER},
-  {ROAR_CMD_GET_VOL,      _NAME("GET_VOL"),      req_on_get_vol,      ACCLEV_GUEST},
-  {ROAR_CMD_GET_STREAM_PARA, _NAME("GET_STREAM_PARA"), req_on_get_stream_para, ACCLEV_GUEST},
-  {ROAR_CMD_SET_STREAM_PARA, _NAME("SET_STREAM_PARA"), req_on_set_stream_para, ACCLEV_PWRUSER},
-
-  {ROAR_CMD_ADD_DATA,     _NAME("ADD_DATA"),     req_on_add_data,     ACCLEV_PWRUSER},
-
-  {ROAR_CMD_BEEP,         _NAME("BEEP"),         req_on_beep,         ACCLEV_USER},
-
-  {ROAR_CMD_WAIT,         _NAME("WAIT"),         req_on_wait,         ACCLEV_USER},
-
-  {ROAR_CMD_EOL,          _NAME("END OF LIST"),  NULL,                ACCLEV_NONE}
+  {ROAR_CMD_EOL,          "END OF LIST",  NULL}
  };
 
@@ -98,39 +43,20 @@
 }
 
-int command_exec (int client, struct roar_message * mes, char ** data, uint32_t flags[2]) {
+int command_exec (int client, struct roar_message * mes, char * data) {
  int cmd = command_get_id_by_cmd(mes->cmd);
- int (*func)(int client, struct roar_message * mes, char ** data, uint32_t flags[2]);
-#ifdef DEBUG
- int ret;
-#endif
+ int (*func)(int client, struct roar_message * mes, char * data);
 
  if ( cmd == -1 )
   return -1;
 
- // NOTE: This is optimized for speed here, so we do not call clients_get().
- // we maybe should do but current just don't. /client/ must be valid anyway.
- if ( g_commands[cmd].minacclev > g_clients[client]->acclev ) {
-  ROAR_WARN("command_exec(client=%i, mes=%p{.cmd=%i,...}, data=%p, flags=%p) = -1 // client not allowed to use command %s", client, mes, (int)mes->cmd, data, flags, g_commands[cmd].name);
+ if ( (func = g_commands[cmd].handler) == NULL )
   return -1;
- }
-
- if ( (func = g_commands[cmd].handler) == NULL ) {
-  ROAR_WARN("command_exec(client=%i, mes=%p{.cmd=%i,...}, data=%p, flags=%p) = -1 // unknown command", client, mes, (int)mes->cmd, data, flags);
-  return -1;
- }
 
  ROAR_DBG("command_exec(*): Execing command %i(%s) via %p", cmd, g_commands[cmd].name, func);
 
-#ifdef DEBUG
- ROAR_DBG("command_exec(client=%i, mes=%p{.cmd=%i,...}, data=%p{%p}, flags=%p): func=%p", client, mes, (int)mes->cmd, data, *data, flags, func);
- ret = func(client, mes, data, flags);
- ROAR_DBG("command_exec(client=%i, mes=%p{.cmd=%i,...}, data=%p{%p}, flags=%p) = %i", client, mes, (int)mes->cmd, data, *data, flags, ret);
- return ret;
-#else
- return func(client, mes, data, flags);
-#endif
+ return func(client, mes, data);
 }
 
-int command_get_name (int command, const char ** name) {
+int command_get_name (int command, char ** name) {
  int cmd = command_get_id_by_cmd(command);
 
